/*
    lib1funcs.h, Copyright (c) by Silvio Dragone & David Reist,
    Swiss Federal Institute of Technology,
    Computer Engineering and Networks Laboratory.
 
    TOPSY -- A Teachable Operating System.
             Implementation of a tiny and simple
             micro kernel for teaching purposes.
 
    For further information, please visit http://www.tik.ee.ethz.ch/~topsy
 
    This software is provided under the terms of the GNU General Public Licence.
 
    A full copy of the GNU GPL is provided in the file COPYING found in the 
    development root of Topsy.
*/

/* unsigned division function */
void __udivsi3(void);

/* signed division function */
void __divsi3(void);

/* unsigned modulo function */
void __umodsi3(void);

/* signed modulo function */
void __modsi3(void);

/* division by zero procedure:
 * This function is not implemented yet, it just jumps back to the caller.
 * But the idea of this procedure is to make a SWI and handle it as an
 * exception. The SWI-handler is allready implemented in the TMHalAsm and is
 * called SyscallExceptionHandler. Declare a new <immed_24> for the SWI 
 * and check for it in the SyscallExceptionHandler ;-)
 */
void __div0(void);
